(function(timezoneJS) {
  var callbacks = [];
  var generateAbbreviation = function(date) {
    return (new timezoneJS.Date(date, 'America/New_York')).getTimezoneAbbreviation();
  };

  timezoneJS.casebook = {
    initialized: false,
    init: function() {
      timezoneJS.timezone.zoneFileBasePath = '/timezones';
      timezoneJS.timezone.init({
        callback: function() {
          timezoneJS.casebook.initialized = true;
          _.each(callbacks, function(callback) { callback() });
        }
      });
    },
    getTimezoneAbbreviation: function(date, callback) {
      if(!timezoneJS.casebook.initialized) {
        callbacks.push( function() { callback(generateAbbreviation(date)) } );
      } else {
        callback(generateAbbreviation(date));
      }
    }
  };

  timezoneJS.casebook.init();
}(timezoneJS));
