(function($) {
  function setLabel($input) {
    timezoneJS.casebook.getTimezoneAbbreviation($input.val(), function(timezoneAbbreviation) {
      $input.parent().siblings('.js-timezone').text(timezoneAbbreviation);
    });
  }

  $(document).on('datepicker:present', function(event) {
    var $target = $(event.target);
    var args = {};
    args.defaultDate = '0';
    args.numberOfMonths = 2;
    args.showCurrentAtPos = 1;
    args.onSelect = function(dateText, inst) {
      $target.trigger('change');
      $target.focus();
    };
    args.minDate = $target.attr('min-date');
    args.maxDate = $target.attr('max-date');
    if ($target.attr('disable-future-dates') === "true") {
      args.maxDate = '0';
    }
    $target.datepicker(args);

    $target.change(function() {
      setLabel($target);
    });

    $target.keydown(function() {
      $target.datepicker("hide");
    });

    var dateValue = $target.val();
    if(dateValue) { setLabel($target); }
  });
})(jQuery);
