(function($) {
  $(document).on('expando:present', function(event){
    var expando = $(event.target);
    var expando_elem = expando.find(".js-expando-elem").first();

    function toggleAriaExpanded() {
      var ariaExpanded = "false";
      if (expando.hasClass("open")) {
        ariaExpanded = "true";
      }
      expando_elem.attr("aria-expanded", ariaExpanded);
    }

    function toggleExpando() {
      expando.toggleClass("open");
      toggleAriaExpanded();
      return true;
    }

    function expandExpando(){
      if(!expando.hasClass('open')) {
        toggleExpando();
      }
    }

    expando_elem.attr("tabindex",0);
    toggleAriaExpanded();

    expando.bind("expandFilters", expandExpando);
    expando_elem.bind("click", toggleExpando);
    expando_elem.keydown(function(e) {
      if (e.keyCode == $.ui.keyCode.SPACE || e.keyCode == $.ui.keyCode.ENTER) {
        toggleExpando();
      } else {
        return true;
      }
    });
  });
})(jQuery);
