class RadioAsAccessibleInput < SimpleForm::Inputs::CollectionInput
  def label
    ""
  end

  def input_type
    "radio"
  end

  def input
    input_options[:collection_wrapper_tag] ||= options.fetch(:collection_wrapper_tag, SimpleForm.collection_wrapper_tag)
    label_method, value_method = detect_collection_methods
    input_dom = @builder.send(:"collection_#{input_type}_buttons",
                              attribute_name, collection,
                              value_method, label_method,
                              input_options, input_html_options)
    if input_options[:required]
      fieldset = "<fieldset class='radio_buttons normal required' aria-required='true'>"
    else
      fieldset = "<fieldset class='radio_buttons normal'>"
    end

    dom = <<-STRING
    #{fieldset}
      <legend>#{input_options[:label]}</legend>
      <div class='options'>
        #{input_dom}
      </div>
    </fieldset>
    STRING
    dom.html_safe
  end
end
