require 'yaml'
require 'undercase/pattern'

module Undercase
  class Category
    attr_reader :name, :patterns

    def initialize(key)
      @name = categories[key]
      @patterns = Pattern.all.select { |pattern| pattern.category == key.to_sym }
    end

    private

    def categories
      file = File.expand_path('../categories.yml', __FILE__)
      YAML.load_file(file)
    end
  end
end
